package liv.jmxmonitor;

import static org.junit.Assert.assertEquals;
import liv.jmxmonitor.FreqMap;

import org.junit.Test;

/**
 * Unit test for {@link FreqMap}.
 *
 * @author Liviu Tudor http://about.me/liviutudor
 */
public class FreqMapTest {
    @Test
    public void testCreate() {
        FreqMap map = new FreqMap();
        assertEquals(map.size(), 0);
        assertEquals(map.getTotal(), 0);
    }

    @Test
    public void testAdd() {
        FreqMap map = new FreqMap();

        // add one by one
        int total = 0;
        int start = 1;
        int end = 10;
        for (int i = start; i <= end; i++) {
            map.add(i);
            total += i;
            assertEquals(map.size(), i);
            assertEquals(map.getTotal(), total);
        }

        for (int i = start; i <= end; i++) {
            assertEquals(map.getFrequency(i), 1);
        }

        // add in arrays
        int arr1[] = new int[] { 20, 30, 40 };
        for (int i = 0; i < arr1.length; i++) {
            map.add(arr1[i]);
            total += arr1[i];
            assertEquals(map.getTotal(), total);
            assertEquals(map.getFrequency(arr1[i]), 1);
        }
        assertEquals(map.size(), end + arr1.length);

        // now add existing numbers
        for (int i = start; i <= end; i++) {
            map.add(i);
            total += i;
            assertEquals(map.size(), end + arr1.length);
            assertEquals(map.getTotal(), total);
            assertEquals(map.getFrequency(i), 2);
        }

        for (int i = 0; i < arr1.length; i++) {
            map.add(arr1[i]);
            total += arr1[i];
            assertEquals(map.size(), end + arr1.length);
            assertEquals(map.getTotal(), total);
            assertEquals(map.getFrequency(arr1[i]), 2);
        }
    }

    @Test
    public void testClear() {
        FreqMap map = new FreqMap();

        // add one by one
        int total = 0;
        int start = 1;
        int end = 10;
        for (int i = start; i <= end; i++) {
            map.add(i);
            total += i;
            assertEquals(map.size(), i);
            assertEquals(map.getTotal(), total);
            assertEquals(map.getFrequency(i), 1);
        }

        // now reset
        map.clear();
        assertEquals(map.size(), 0);
        assertEquals(map.getTotal(), 0);
        for (int i = start; i <= end; i++) {
            assertEquals(map.getFrequency(i), 0);
        }
    }
}
